;******************************************************************************
;*      BTLOON.LSP - The Ultimate Ballooning Program                          *
;*                                                                            *
;*  This is a ShareWare program written by Brunette Technologies              *
;*  For information on how to register see readme.bat or write to             *
;*  Brunette Technologies, 618 Park St., Chilton, WI  53014                   * 
;*                                                                            *
;*  This program allows continuous entry of balloons with                     *
;*  an infinite choice of diameters and variable arrow lines.                 *
;*  You also have a choice of incrementing or repeating                       *
;*  balloon numbers.                                                          *
;*                                                                            *
;******************************************************************************
(defun C:BTLOON()
    (setvar "CMDECHO" 0)
    (setvar "MENUECHO" 1)
    (GRAPHSCR)
(if (= loonlayer nil)(setq loonlayer "Balloons"))
(if (= looncolor nil)(setq looncolor "12"))
(if (= loonsize nil)(setq loonsize 0.375))
(if (= looninc nil)(setq looninc "I"))
(setq INCGET 0)
(command "viewres" "Y" 1250)
(print)(print)
(princ "\n     Enter balloon layer... <")(princ loonlayer)(princ ">... ")
  (print)
  (setq blayer (getstring "                            "))
  (if (/= blayer "")(setq loonlayer blayer))
(print)
(princ "\n     Enter Balloon Color... <")(princ looncolor)(princ ">... ")
  (print)
  (setq bcolor (getstring "                            "))
  (if (/= bcolor "")(setq looncolor bcolor))
  (COMMAND "LAYER" "M" loonlayer "C" looncolor """")
(print)(print)
(princ "\n     Enter Balloon Size...<")(princ loonsize)(princ ">...?   ")
  (print)
  (setq aa (getreal "                          "))
  (if (/= aa nil) (setq loonsize aa))
(setq bx "-BTLOON" B 1)
(SETQ BB (* loonsize 0.5))
(while (= INCGET 0)
  (print) 
  (princ "\n Increment or Repeat Balloon Numbers, I or R..  <")
  (princ LOONINC)(princ ">?")
  (print)
  (SETQ INC (getstring "                                                 "))
  (if (= INC "")(setq INC LOONINC))
  (setq INCGET (cond ((= INC "I") "I")
                     ((= INC "i") "I")
                     ((= INC "R") "R")
                     ((= INC "r") "R")
                     (t 0)    
                ))
  (if (/= INCGET 0)(setq LOONINC INCGET))
)
(while (<= 0 1)
   (COND ((= INCGET "R")(princ "\n 'RETURN' Repeats Balloon #"))
         ((= INCGET "I")(princ "\n 'RETURN' Increments Balloon #"))
   )
      (princ B) (print)
      (setq BN (getint "\n      Enter Balloon Number, <Max. 3 Digits>...  "))
      (if (= BN nil)
          (if (= INCGET "I") (setq b (+ b 1)))
          (setq B BN)
      )
      (print)  (print)
(princ "     Locate Balloon #")(princ b)(princ " Center...")
           (print)
           (command "INSERT" bx "scale" LOONSIZE pause "0" b)
           (setq x (getvar "lastpoint"))         (print)
(print " 'RETURN' For Balloon Only")             (print)
      (setq Y (getpoint "\n      Locate Arrow Tip..."))
         (IF (/= Y NIL) (SETQ C 1))
    (setq d 1)
    (setq s1 y)
    (setq f x)
    (setq s2 nil)
    (setq e 1)
(WHILE (= C 1)
    (while (= d 1)                               (print)     (print)
(print " 'RETURN' Draws Line To Balloon")        (print)
    (print "      Locate Next Point...")
              (command "line" s1 pause)
                   (command "")                  (PRINT)
         (setq s2 (getvar "lastpoint"))
         (if (equal s2 s1) (setq d 0) (setq d 2))
         (if (equal s2 s1) (setq e 2))
         (if (= e 1) (setq f s2))
         (setq e (+ e 1))
    (while (= d 2)
         (setq s1 s2)
         (setq d 1)
    )
    )
           (setq Z (/ (* (angle Y f) 180) PI))
           (command "INSERT" "-arrow" Y bb bb Z)
           (command "LINE" s1 "None" (polar s1 (angle s1 x) 
                              (- (distance s1 x) (* 0.5 LOONSIZE)))"")
           (print " 'RETURN' For Balloon Only")             (print)
      (setq Y (getpoint "\n      Locate Arrow Tip..."))
         (IF (= Y NIL) (SETQ C 2) (SETQ C 1))
    (setq d 1)
    (setq s1 y)
    (setq f x)
    (setq s2 nil)
    (setq e 1)
)
)
)
